<?php
/*
     RowJSPage Mediawiki extension. include javascript code from MediaWiki namespace.
     See detail http://metabolomics.jp/wiki/Help:Extension/RemoteSearch
     Last-modified: 2011.02.27
     Version: 0.11
       - change url in {{#includejs;}}

     Version: 0.1 2009.09.07

     *********************************************************************

     Copyright (C) 2009-2011 Metabolomics.JP Development Team

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

     *********************************************************************
     Author: Arita laboratory, with Kazuhiro Suwa <metabolome@cb.k.u-tokyo.ac.jp>
     URL: http://metabolomics.jp/
*/
 
if ( !defined( 'MEDIAWIKI' ) ) {
	die( 'This file is a MediaWiki extension, see <a href="http://metabolomics.jp/wiki/Help:Extension/RowJSPage">RowJSPage.php</a>.' );
}

$wgExtensionFunctions[] = 'efSetupRowJSPageFunctions';
$wgHooks['LanguageGetMagic'][] = 'efRowJSPageFunctionsLanguageGetMagic';
$wgExtensionCredits['parserhook'][] = array(
        'name' => 'RowJSPageFunctions',
        'version' => '0.11',
        'author' => 'K, Suwa',
        'description' => 'Include Mediawiki:???.js',
        'url' => 'http://metabolomics.jp/wiki/Help:Extension/RowJSPage',
);

$wgAutoloadClasses['RowJSPage'] = dirname(__FILE__) . '/RowJSPage.body.php';
$wgSpecialPages['RowJSPage'] = 'RowJSPage';
$wgHooks['LoadAllMessages'][] = 'RowJSPage::loadMessages';
$wgHooks['LanguageGetSpecialPageAliases'][] = 'efRowJSPageSetup';
 
$wgExtensionCredits['specialpage'][] = array(
	'name' => 'RowJSPage',
	'version' => '0.1',
	'author' => 'K, Suwa',
	'description' => 'include javascript code from MediaWiki namespace',
        'url' => 'http://metabolomics.jp/wiki/Help:Extension/RowJSPage',
);

$egRowJSPagePrefix = 'rjs_';
global $egRowJSPagePrefix;

function efRowJSPageSetup( &$specialPageArray, $code ) {

	RowJSPage::loadMessages();
	$text = wfMsg('rowjspage');
 
	$title = Title::newFromText( $text );
	$specialPageArray['RowJSPage'][] = 'RowJSPage';
 
	return true;
}

class RowJSPageFunctions
{
	/**
	 * include js code for googleapi
	 */
	function googleapi( &$parser )
	{
	        global $wgOut;

		if( !$this->checkTitle( $parser ) )
			return;

	        $wgOut->addScript("<script type=\"text/javascript\" src=\"http://www.google.com/jsapi\"></script>\n");
	}

	/**
	 * include javascript page in
	 *
	 * @param $parser Parser Parent parser
	 * @param $js javascript page which in MediaWiki namespace
	 * @param $args1..n arguments
	 * @return repeated string
	 */
	function includejs( )
	{
	        global $wgOut, $egRowJSPagePrefix, $wgTitle;

		$argv = func_get_args();
		if( count( $argv ) < 2 )
			return "";

		$parser = $argv[0];
		$jspage = $argv[1];

		if( !$this->checkTitle( $parser ) )
			return;

#`echo "abc" >> /tmp/log`;
		$arg = "";
		for( $i = 2; $i < count( $argv ); $i ++ ){
			$arg .= "&" . $egRowJSPagePrefix . ($i-1) . "=" . $argv[$i];
		}
	        $wgOut->addScript("<script type=\"text/javascript\" src=\"/wiki/Special:RowJSPage?" . $egRowJSPagePrefix . "page=$jspage$arg\"></script>\n");

	        return;
	}

	function checkTitle( &$parser )
	{
		global $wgTitle;

		$mainNamespace = Namespace::getCanonicalName( $wgTitle->getNamespace() );
		$mainTitle     = $wgTitle->getText();
		if( strlen( $mainNamespace ) > 0 )
			$mainTitle = $mainNamespace . ":" . $mainTitle;
		$parseTitle    = $parser->getTitle();
#$a = strcmp( $mainTitle, $parseTitle );
#`echo "$mainTitle $parseTitle $a" >> /tmp/log`;
		if( strcmp( $mainTitle, $parseTitle ) == 0 )
			return true;
		return false;
	}
}

function efSetupRowJSPageFunctions()
{
        global $wgParser;

        $rowJSPageFunctions = new RowJSPageFunctions;

        $wgParser->setFunctionHook( 'googleapi', array( &$rowJSPageFunctions, 'googleapi' ) );
        $wgParser->setFunctionHook( 'includejs', array( &$rowJSPageFunctions, 'includejs' ) );
}

function efRowJSPageFunctionsLanguageGetMagic( &$magicWords, $langCode )
{
        $magicWords['googleapi'] = array( 0, 'googleapi' );
        $magicWords['includejs'] = array( 0, 'includejs' );

        return true;
}

